import { ComponentOptions } from 'vue';
import { ComponentPublicInstance } from 'vue';
import { SetupContext } from 'vue';
import { UnwrapRef } from 'vue';
import { VNode } from 'vue';

export declare interface ClassComponentHooks {
}

export declare function createDecorator(factory: (options: ComponentOptions, key: string, index: number) => void): VueDecorator;

export declare type ExtractInstance<T> = T extends VueMixin<infer V> ? V : never;

export declare type MixedVueBase<Mixins extends VueMixin[]> = Mixins extends (infer T)[] ? VueBase<UnionToIntersection<ExtractInstance<T>> & Vue> & PropsMixin : never;

export declare function mixins<T extends VueMixin[]>(...Ctors: T): MixedVueBase<T>;

export declare function Options<V extends Vue>(options: ComponentOptions & ThisType<V>): <VC extends VueBase>(target: VC) => VC;

export declare interface PropsMixin {
    new <Props = unknown>(...args: any[]): {
        $props: Props;
    };
}

export declare function setup<R>(setupFn: () => R): UnwrapRef<R>;

export declare type UnionToIntersection<U> = (U extends any ? (k: U) => void : never) extends (k: infer I) => void ? I : never;

export declare class Vue<Props = unknown> implements ComponentPublicInstance<{}, {}, {}, {}, {}, {}, Props>, ClassComponentHooks {
    /* Excluded from this release type: __vccCache */
    /* Excluded from this release type: __vccBase */
    /* Excluded from this release type: __vccDecorators */
    /* Excluded from this release type: __vccMixins */
    /* Excluded from this release type: __vccHooks */
    /* Excluded from this release type: __vccOpts */
    static registerHooks(keys: string[]): void;
    $: ComponentPublicInstance['$'];
    $data: ComponentPublicInstance['$data'];
    $refs: ComponentPublicInstance['$refs'];
    $root: ComponentPublicInstance['$root'];
    $parent: ComponentPublicInstance['$parent'];
    $el: ComponentPublicInstance['$el'];
    $options: ComponentPublicInstance['$options'];
    $forceUpdate: ComponentPublicInstance['$forceUpdate'];
    $nextTick: ComponentPublicInstance['$nextTick'];
    $watch: ComponentPublicInstance['$watch'];
    $props: Props;
    $emit: (event: string, ...args: any[]) => void;
    $attrs: ComponentPublicInstance['$attrs'];
    $slots: ComponentPublicInstance['$slots'];
    data?(): object;
    beforeCreate?(): void;
    created?(): void;
    beforeMount?(): void;
    mounted?(): void;
    beforeUnmount?(): void;
    unmounted?(): void;
    beforeUpdate?(): void;
    updated?(): void;
    activated?(): void;
    deactivated?(): void;
    render?(): VNode | void;
    errorCaptured?(err: Error, vm: Vue, info: string): boolean | undefined;
    serverPrefetch?(): Promise<unknown>;
    static render?: () => VNode | void;
    static __file?: string;
    static __cssModules?: Record<string, any>;
    static __scopeId?: string;
    constructor(props: Props, ctx: SetupContext);
}

export declare type VueBase<V extends Vue = Vue> = VueMixin<V> & (new (...args: any[]) => V);

export declare interface VueDecorator {
    (Ctor: VueBase): void;
    (target: Vue, key: string): void;
    (target: Vue, key: string, index: number): void;
}

export declare type VueMixin<V extends Vue = Vue> = VueStatic & {
    prototype: V;
};

export declare type VueStatic = {
    [K in keyof typeof Vue]: typeof Vue[K];
};

export { }
